/**
 * This file was autogenerated by make_blade.b and should 
 * NOT be manually modified as any manual modification will be 
 * lost whenever the script is run. This file is meant to be 
 * part of the final Blade distribution as a single header file 
 * that allow developers link against libblade when writing 
 * libraries based on the C API.
 */

// Generated at 2024-10-17T00:25:44+00:00

/**
 * Blade Programming Language and the Standard implementation are copyrighted 
 * free software by Richard Ore <eqliqandfriends@gmail.com>.
 * 
 * You can redistribute it and/or modify it under either the terms of the
 * 2-clause BSDL (see the file BSDL), or the conditions below:
 * 
 * 1. You may make and give away verbatim copies of the source form of the
 *    software without restriction, provided that you duplicate all of the
 *    original copyright notices and associated disclaimers.
 * 
 * 2. You may modify your copy of the software in any way, provided that
 *    you do at least ONE of the following:
 * 
 *    a. place your modifications in the Public Domain or otherwise
 *       make them Freely Available, such as by posting said
 *       modifications to Usenet or an equivalent medium, or by allowing
 *       the author to include your modifications in the software.
 * 
 *    b. use the modified software only within your corporation or
 *       organization.
 * 
 *    c. give non-standard binaries non-standard names, with
 *       instructions on where to get the original software distribution.
 * 
 *    d. make other distribution arrangements with the author.
 * 
 * 3. You may distribute the software in object code or binary form,
 *    provided that you do at least ONE of the following:
 * 
 *    a. distribute the binaries and library files of the software,
 *       together with instructions (in the manual page or equivalent)
 *       on where to get the original distribution.
 * 
 *    b. accompany the distribution with the machine-readable source of
 *       the software.
 * 
 *    c. give non-standard binaries non-standard names, with
 *       instructions on where to get the original software distribution.
 * 
 *    d. make other distribution arrangements with the author.
 * 
 * 4. You may modify and include the part of the software into any other
 *    software (possibly commercial).  But some files in the distribution
 *    are not written by the author, so that they are not under these terms.
 * 
 *    For the list of those files and their copying conditions, see the
 *    file LEGAL.
 * 
 * 5. The scripts and library files supplied as input to or produced as
 *    output from the software do not automatically fall under the
 *    copyright of the software, but belong to whomever generated them,
 *    and may be sold commercially, and may be aggregated with this
 *    software.
 * 
 * 6. THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
 *    IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 *    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *    PURPOSE.
 * 
 */


#ifndef BLADE_CONFIG_H
#define BLADE_CONFIG_H

#define BLADE_EXTENSION ".b"
#define BLADE_VERSION_STRING "0.0.86-alpha"
#define BVM_VERSION "0.1.1"
#define LIBRARY_DIRECTORY "libs"
#define LIBRARY_DIRECTORY_INDEX "index"
#define PACKAGES_DIRECTORY "apps"
#define LOCAL_PACKAGES_DIRECTORY ".blade"
#define LOCAL_EXT_DIRECTORY "/bin"
#define LOCAL_SRC_DIRECTORY "/libs"

// global debug mode flag
#define DEBUG_MODE 0

#define MAX_USING_CASES 256
#define MAX_FUNCTION_PARAMETERS 255
#define FRAMES_MAX 512
#define ERRORS_MAX 512
#define NUMBER_FORMAT "%.16g"
#define MAX_INTERPOLATION_NESTING 8
#define MAX_EXCEPTION_HANDLERS 16

// Maximum load factor of 12/14
// see: https://engineering.fb.com/2019/04/25/developer-tools/f14/
#define TABLE_MAX_LOAD 0.85714286

#define GC_HEAP_GROWTH_FACTOR 1.25

#define USE_NAN_BOXING 1
#define PCRE2_CODE_UNIT_WIDTH 8

#define BLADE_PACKAGE_ROOT_ENV "BLADE_PKG_ROOT"

#define HAVE_GETOPT_H
#define HAVE_TERMIOS_H
#define HAVE_UNISTD_H
#define HAVE_SYS_TIME_H
#define HAVE_SYS_UTSNAME_H
#define HAVE_SYS_ERRNO_H
#define HAVE_DIRENT_H
#define HAVE_DLFCN_H

#define HAVE_ASPRINTF
#define HAVE_STRSEP
#define HAVE_GETTIMEOFDAY
#define HAVE_UTIME
#define HAVE_BASENAME
#define HAVE_DIRNAME
#define HAVE_SYSCONF
/* #undef HAVE_SYSCTLBYNAME */
#define HAVE_SETJMP

#endif


#ifndef BLADE_COMMON_H
#define BLADE_COMMON_H

// special definitions for Cygwin
#define _DEFAULT_SOURCE 1
#define _GNU_SOURCE 1
#define _ln_

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>



#ifdef __GNUC__
#define UNUSED __attribute__((unused))
#elif defined(_MSC_VER)
#define UNUSED __pragma(warning(suppress: 4100 4101 4189))
#else
    #define UNUSED
#endif

#ifdef __GNUC__
#define DISABLE_WARNING_PUSH _Pragma("GCC diagnostic push")
#define DISABLE_WARNING_POP _Pragma("GCC diagnostic pop")
#define DISABLE_WARNING(w) _Pragma(GCC diagnostic ignored #w)
#elif defined(_MSC_VER)
#define DISABLE_WARNING_PUSH __pragma(warning(push))
    #define DISABLE_WARNING_POP __pragma(warning(pop))
    #define DISABLE_WARNING(w) __pragma(warning(disable:w))
#else
    #define DISABLE_WARNING_PUSH
    #define DISABLE_WARNING_POP
    #define DISABLE_WARNING(w)
#endif


// --> debug mode options starts here...
#if DEBUG_MODE == 1

#define DEBUG_PRINT_CODE 1
#define DEBUG_TABLE 0
#define DEBUG_GC 0
#define DEBUG_STACK 0

#define dbg(x) do { x; } while(0)
#define cond_dbg(c, x) do { if((c)) { x; } } while(0)

#else
#define dbg(x)
#define cond_dbg(c, x)
#endif

// --> debug mode options ends here...

#define UINT8_COUNT (UINT8_MAX + 1)
#define UINT16_COUNT (UINT16_MAX + 1)
// #define STACK_MAX (FRAMES_MAX * UINT16_COUNT)
#define STACK_MIN (FRAMES_MAX * UINT8_COUNT)

#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__))
#define IS_UNIX
#elif defined _WIN32
// #define NO_OLDNAMES
#endif

#define VERSION(x) #x
#define VERSION_STRING(name, major, minor, patch)                              \
  name " " VERSION(major) "." VERSION(minor) "." VERSION(patch)

#ifdef __clang__

#define COMPILER  ("Clang " __clang_version__)

#elif defined(_MSC_VER)

#define COMPILER VERSION_STRING("MSC", _MSC_VER, 0, 0)

#elif defined(__MINGW32_MAJOR_VERSION)

#define COMPILER                                                               \
  VERSION_STRING("MinGW32", __MINGW32_MAJOR_VERSION, __MINGW32_MINOR_VERSION, 0)

#elif defined(__MINGW64_VERSION_MAJOR)

#define COMPILER                                                               \
  VERSION_STRING("MinGW-64", __MINGW64_VERSION_MAJOR, __MINGW64_VERSION_MAJOR, \
                 0)

#elif defined(__GNUC__)

#define COMPILER                                                               \
  VERSION_STRING("GCC", __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__)

#else

#define COMPILER "Unknown Compiler"

#endif

#if defined(__APPLE__) && defined(__MACH__) // Apple OSX and iOS (Darwin)
#define LIBRARY_FILE_EXTENSION ".dylib"
#elif defined(_WIN32)
#define LIBRARY_FILE_EXTENSION ".dll"
#else
#define LIBRARY_FILE_EXTENSION ".so"
#endif

#define DEFAULT_GC_START (1024 * 1024)

#if defined(_WIN32) && !defined(errno) 
#define errno (GetLastError())
#endif


#define EXIT_COMPILE 10
#define EXIT_RUNTIME 11
#define EXIT_TERMINAL 12

#define BLADE_COPYRIGHT "\tCopyright (c) Ore Richard Muyiwa"

#endif


#ifndef BLADE_BLOB_H
#define BLADE_BLOB_H

#ifndef BLADE_VALUE_H
#define BLADE_VALUE_H

#include <string.h>


#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

typedef struct s_obj b_obj;
typedef struct s_obj_string b_obj_string;
typedef struct s_obj_list b_obj_list;
typedef struct s_obj_module b_obj_module;
typedef struct s_vm b_vm;

typedef union {
  uint64_t bits;
  double num;
} b_double_union;

#if defined(USE_NAN_BOXING) && USE_NAN_BOXING

// binary representation = 1111111111111 i.e.
// 11 bits + 1 bit for quiet nan and another
// bit to dodge intel's QNaN Floating-Point Indefinite bit
#define QNAN ((uint64_t)0x7ffc000000000000)

#define SIGN_BIT ((uint64_t)0x8000000000000000)

#define EMPTY_TAG 0 // 00
#define NIL_TAG 1   // 01
#define FALSE_TAG 2 // 10
#define TRUE_TAG 3  // 11

typedef uint64_t b_value;

#define FALSE_VAL ((b_value)(uint64_t)(QNAN | FALSE_TAG))
#define TRUE_VAL ((b_value)(uint64_t)(QNAN | TRUE_TAG))

#define EMPTY_VAL ((b_value)(uint64_t)(QNAN | EMPTY_TAG))
#define NIL_VAL ((b_value)(uint64_t)(QNAN | NIL_TAG))
#define BOOL_VAL(v) ((v) ? TRUE_VAL : FALSE_VAL)
#define NUMBER_VAL(v) number_to_value(v)
#define INTEGER_VAL(v) integer_to_value(v)
#define LONG_VAL(v) long_to_value(v)
#define OBJ_VAL(obj) (b_value)(SIGN_BIT | QNAN | (uint64_t)(uintptr_t)(obj))

#define AS_BOOL(v) ((v) == TRUE_VAL)
#define AS_NUMBER(v) value_to_number(v)
#define AS_OBJ(v) ((b_obj *)(uintptr_t)((v) & ~(SIGN_BIT | QNAN)))

#define IS_EMPTY(v) ((v) == EMPTY_VAL)
#define IS_NIL(v) ((v) == NIL_VAL)
#define IS_BOOL(v) (((v) | 1) == TRUE_VAL)
#define IS_NUMBER(v) (((v)&QNAN) != QNAN)
#define IS_OBJ(v) (((v) & (QNAN | SIGN_BIT)) == (QNAN | SIGN_BIT))

static inline b_value number_to_value(double v) {
  b_value value;
  memcpy(&value, &v, sizeof(double));
  return value;
}

static inline b_value integer_to_value(int v) {
  b_double_union data;
  data.num = (double) v;
  return data.bits;
}

static inline b_value long_to_value(long v) {
  b_double_union data;
  data.num = (double) v;
  return data.bits;
}

static inline double value_to_number(b_value v) {
  double number;
  memcpy(&number, &v, sizeof(b_value));
  return number;
}

#else

typedef enum {
  VAL_NIL,
  VAL_BOOL,
  VAL_NUMBER,
  VAL_OBJ,
  VAL_EMPTY,
} b_val_type;

typedef struct {
  b_val_type type;
  union {
    bool boolean;
    double number;
    b_obj *obj;
  } as;
} b_value;

// promote C values to blade value
#define EMPTY_VAL ((b_value){VAL_EMPTY, {.number = 0}})
#define NIL_VAL ((b_value){VAL_NIL, {.number = 0}})
#define TRUE_VAL ((b_value){VAL_BOOL, {.boolean = true}})
#define FALSE_VAL ((b_value){VAL_BOOL, {.boolean = false}})
#define BOOL_VAL(v) ((b_value){VAL_BOOL, {.boolean = v}})
#define NUMBER_VAL(v) ((b_value){VAL_NUMBER, {.number = v}})
#define INTEGER_VAL(v) ((b_value){VAL_NUMBER, {.number = v}})
#define LONG_VAL(v) ((b_value){VAL_NUMBER, {.number = v}})
#define OBJ_VAL(v) ((b_value){VAL_OBJ, {.obj = (b_obj *)v}})

// demote blade values to C value
#define AS_BOOL(v) ((v).as.boolean)
#define AS_NUMBER(v) ((v).as.number)
#define AS_OBJ(v) ((v).as.obj)

// testing blade value types
#define IS_NIL(v) ((v).type == VAL_NIL)
#define IS_BOOL(v) ((v).type == VAL_BOOL)
#define IS_NUMBER(v) ((v).type == VAL_NUMBER)
#define IS_OBJ(v) ((v).type == VAL_OBJ)
#define IS_EMPTY(v) ((v).type == VAL_EMPTY)

#endif

typedef struct {
  int capacity;
  int count;
  b_value *values;
} b_value_arr;

typedef struct {
  int count;
  unsigned char *bytes;
} b_byte_arr;

void init_value_arr(b_value_arr *array);

void free_value_arr(b_vm *vm, b_value_arr *array);

void write_value_arr(b_vm *vm, b_value_arr *array, b_value value);

void insert_value_arr(b_vm *vm, b_value_arr *array, b_value value, int index);

void print_value(b_value value);

void echo_value(b_value value);

const char *value_type(b_value value);

bool values_equal(b_value a, b_value b);

b_obj_string *value_to_string(b_vm *vm, b_value value);

void init_byte_arr(b_byte_arr *array, int length);

void take_byte_arr(b_vm *vm, b_byte_arr *array, unsigned char data, int length);

void free_byte_arr(b_vm *vm, b_byte_arr *array);

// hash
uint32_t hash_string(const char *key, int length);

uint32_t hash_value(b_value value);

void sort_values(b_value *values, int count);

b_value copy_value(b_vm *vm, b_value value);

#define EMPTY_STRING_VAL OBJ_VAL(copy_string(vm, "", 0))
#define STRING_VAL(val) OBJ_VAL(copy_string(vm, val, (int)strlen(val)))
#define STRING_L_VAL(val, l) OBJ_VAL(copy_string(vm, val, l))
#define STRING_T_VAL(val, l) OBJ_VAL(take_string(vm, val, l))
#define STRING_TT_VAL(val) OBJ_VAL(take_string(vm, val, (int)strlen(val)))
#define BYTES_VAL(val) OBJ_VAL(take_bytes(vm, (unsigned char *)(val), (int)strlen((char *)(val))))
#define PTR_VAL(val) OBJ_VAL(new_ptr(vm, val))

#ifdef __cplusplus
}
#endif // __cplusplus

#endif

typedef enum {
  OP_DEFINE_GLOBAL,
  OP_GET_GLOBAL,
  OP_SET_GLOBAL,

  OP_GET_LOCAL,
  OP_GET_UP_VALUE,
  OP_SET_LOCAL,
  OP_SET_UP_VALUE,
  OP_CLOSE_UP_VALUE,
  OP_GET_PROPERTY,
  OP_GET_SELF_PROPERTY,
  OP_SET_PROPERTY,

  OP_JUMP_IF_FALSE,
  OP_JUMP,
  OP_LOOP,

  OP_EQUAL,
  OP_GREATER,
  OP_LESS,

  OP_EMPTY,
  OP_NIL,
  OP_TRUE,
  OP_FALSE,
  OP_ADD,
  OP_SUBTRACT,
  OP_MULTIPLY,
  OP_DIVIDE,
  OP_F_DIVIDE, // floor divide
  OP_REMINDER,
  OP_POW,
  OP_NEGATE,
  OP_NOT,
  OP_BIT_NOT,
  OP_AND,
  OP_OR,
  OP_XOR,
  OP_LSHIFT,
  OP_RSHIFT,
  OP_ONE,

  OP_CONSTANT, // 8-bit constant address (0 - 255)
  OP_ECHO,
  OP_POP,
  OP_DUP,
  OP_POP_N,
  OP_ASSERT,
  OP_RAISE,

  OP_CLOSURE,
  OP_CALL,
  OP_INVOKE,
  OP_INVOKE_SELF,
  OP_RETURN,

  OP_CLASS,
  OP_METHOD,
  OP_CLASS_PROPERTY,
  OP_INHERIT,
  OP_GET_SUPER,
  OP_SUPER_INVOKE,
  OP_SUPER_INVOKE_SELF,

  OP_RANGE,
  OP_LIST,
  OP_DICT,
  OP_GET_INDEX,
  OP_GET_RANGED_INDEX,
  OP_SET_INDEX,

  OP_CALL_IMPORT,
  OP_NATIVE_MODULE,
  OP_SELECT_IMPORT,
  OP_SELECT_NATIVE_IMPORT,
  OP_IMPORT_ALL_NATIVE,
  OP_EJECT_IMPORT,
  OP_EJECT_NATIVE_IMPORT,
  OP_IMPORT_ALL,

  OP_BEGIN_CATCH,
  OP_END_CATCH,

  OP_STRINGIFY,
  OP_SWITCH,
  OP_CHOICE,

  // the break placeholder... it never gets to the vm
  // care should be taken to
  OP_BREAK_PL,
} b_code;

typedef struct {
  int count;
  int capacity;
  uint8_t *code;
  int *lines;
  b_value_arr constants;
} b_blob;

void init_blob(b_blob *blob);

void free_blob(b_vm *vm, b_blob *blob);

void write_blob(b_vm *vm, b_blob *blob, uint8_t byte, int line);

int add_constant(b_vm *vm, b_blob *blob, b_value value);

#endif

#ifndef BLADE_DEBUG_H
#define BLADE_DEBUG_H


void disassemble_blob(b_blob *blob, const char *name);

int disassemble_instruction(b_blob *blob, int offset);

#endif

#ifndef BLADE_TABLE_H
#define BLADE_TABLE_H


typedef struct {
  b_value key;
  b_value value;
} b_entry;

typedef struct {
  int count;
  int capacity;
  b_entry *entries;
} b_table;

void init_table(b_table *table);

void free_table(b_vm *vm, b_table *table);

void clean_free_table(b_vm *vm, b_table *table);

bool table_set(b_vm *vm, b_table *table, b_value key, b_value value);

bool table_get(b_table *table, b_value key, b_value *value);

bool table_delete(b_table *table, b_value key);

void table_add_all(b_vm *vm, b_table *from, b_table *to);
void table_copy(b_vm *vm, b_table *from, b_table *to);

b_obj_string *table_find_string(b_table *table, const char *chars, int length,
                                uint32_t hash);

b_value table_find_key(b_table *table, b_value value);
b_obj_list *table_get_keys(b_vm *vm, b_table *table);

void table_print(b_table *table);

void mark_table(b_vm *vm, b_table *table);

void table_remove_whites(b_vm *vm, b_table *table);

void table_import_all(b_vm *vm, b_table *from, b_table *to);

#endif

#ifndef BLADE_OBJECT_H
#define BLADE_OBJECT_H


#include <stdio.h>

typedef enum {
  TYPE_ANONYMOUS,
  TYPE_FUNCTION,
  TYPE_METHOD,
  TYPE_INITIALIZER,
  TYPE_PRIVATE,
  TYPE_STATIC,
  TYPE_SCRIPT,
} b_func_type;

#define OBJ_TYPE(v) (AS_OBJ(v)->type)

// object type checks
#define IS_STRING(v) is_obj_type(v, OBJ_STRING)
#define IS_NATIVE(v) is_obj_type(v, OBJ_NATIVE)
#define IS_FUNCTION(v) is_obj_type(v, OBJ_FUNCTION)
#define IS_CLOSURE(v) is_obj_type(v, OBJ_CLOSURE)
#define IS_CLASS(v) is_obj_type(v, OBJ_CLASS)
#define IS_INSTANCE(v) is_obj_type(v, OBJ_INSTANCE)
#define IS_BOUND(v) is_obj_type(v, OBJ_BOUND_METHOD)

// containers
#define IS_BYTES(v) is_obj_type(v, OBJ_BYTES)
#define IS_LIST(v) is_obj_type(v, OBJ_LIST)
#define IS_DICT(v) is_obj_type(v, OBJ_DICT)
#define IS_FILE(v) is_obj_type(v, OBJ_FILE)
#define IS_RANGE(v) is_obj_type(v, OBJ_RANGE)

// promote b_value to object
#define AS_STRING(v) ((b_obj_string *)AS_OBJ(v))
#define AS_NATIVE(v) ((b_obj_native *)AS_OBJ(v))
#define AS_FUNCTION(v) ((b_obj_func *)AS_OBJ(v))
#define AS_CLOSURE(v) ((b_obj_closure *)AS_OBJ(v))
#define AS_CLASS(v) ((b_obj_class *)AS_OBJ(v))
#define AS_INSTANCE(v) ((b_obj_instance *)AS_OBJ(v))
#define AS_BOUND(v) ((b_obj_bound *)AS_OBJ(v))

// non-user objects
#define AS_SWITCH(v) ((b_obj_switch *)AS_OBJ(v))
#define IS_SWITCH(v) is_obj_type(v, OBJ_SWITCH)
#define AS_PTR(v) ((b_obj_ptr *)AS_OBJ(v))
#define IS_PTR(v) is_obj_type(v, OBJ_PTR)
#define AS_MODULE(v) ((b_obj_module *)AS_OBJ(v))
#define IS_MODULE(v) is_obj_type(v, OBJ_MODULE)

// containers
#define AS_BYTES(v) ((b_obj_bytes *)AS_OBJ(v))
#define AS_LIST(v) ((b_obj_list *)AS_OBJ(v))
#define AS_DICT(v) ((b_obj_dict *)AS_OBJ(v))
#define AS_FILE(v) ((b_obj_file *)AS_OBJ(v))
#define AS_RANGE(v) ((b_obj_range *)AS_OBJ(v))

// demote blade value to c string
#define AS_C_STRING(v) (((b_obj_string *)AS_OBJ(v))->chars)

#define IS_CHAR(v) (IS_STRING(v) && (AS_STRING(v)->length == 1 || AS_STRING(v)->length == 0))

typedef enum {
  // containers
  OBJ_STRING,
  OBJ_RANGE,
  OBJ_LIST,
  OBJ_DICT,
  OBJ_FILE,
  OBJ_BYTES,

  // base object types
  OBJ_UP_VALUE,
  OBJ_BOUND_METHOD,
  OBJ_CLOSURE,
  OBJ_FUNCTION,
  OBJ_INSTANCE,
  OBJ_NATIVE,
  OBJ_CLASS,

  // non-user objects
  OBJ_MODULE,
  OBJ_SWITCH,
  OBJ_PTR,  // object type that can hold any C pointer
} b_obj_type;

struct s_obj {
  b_obj_type type;
  bool mark;

  // when an object is marked as stale, it means that the
  // GC will never collect this object. This can be useful
  // for library/package objects that want to reuse native
  // objects in their types/pointers. The GC cannot reach
  // them yet, so it's best for them to be kept stale.
  bool stale;
  struct s_obj *next;
};

struct s_obj_string {
  b_obj obj;
  int length;
  int utf8_length;
  bool is_ascii;
  uint32_t hash;
  char *chars;
};

typedef struct b_obj_up_value {
  b_obj obj;
  b_value closed;
  b_value *location;
  struct b_obj_up_value *next;
} b_obj_up_value;

struct s_obj_module {
  b_obj obj;
  bool imported;
  b_table values;
  char *name;
  char *file;
  void *preloader;
  void *unloader;
  void *handle;
  b_obj_module *parent;
};

typedef struct {
  b_obj obj;
  b_func_type type;
  int arity;
  int up_value_count;
  bool is_variadic;
  b_blob blob;
  b_obj_string *name;
  b_obj_module *module;
} b_obj_func;

typedef struct {
  b_obj obj;
  int up_value_count;
  b_obj_func *function;
  b_obj_up_value **up_values;
} b_obj_closure;

typedef struct b_obj_class {
  b_obj obj;
  b_value initializer;
  b_table properties;
  b_table static_properties;
  b_table methods;
  b_obj_string *name;
  struct b_obj_class *superclass;
} b_obj_class;

typedef struct {
  b_obj obj;
  b_table properties;
  b_obj_class *klass;
} b_obj_instance;

typedef struct {
  b_obj obj;
  b_value receiver;
  b_obj_closure *method;
} b_obj_bound; // a bound method

typedef bool (*b_native_fn)(b_vm *, int, b_value *);
typedef void (*b_ptr_free_fn)(void *);

typedef struct b_obj_native {
  b_obj obj;
  b_func_type type;
  const char *name;
  b_native_fn function;
} b_obj_native;

struct s_obj_list {
  b_obj obj;
  b_value_arr items;
};

typedef struct {
  b_obj obj;
  int lower;
  int upper;
  int range;
} b_obj_range;

typedef struct {
  b_obj obj;
  b_byte_arr bytes;
} b_obj_bytes;

typedef struct {
  b_obj obj;
  b_value_arr names;
  b_table items;
} b_obj_dict;

typedef struct {
  b_obj obj;
  bool is_open;
  bool is_std;
  bool is_tty;
  int number;
  FILE *file;
  b_obj_string *mode;
  b_obj_string *path;
} b_obj_file;

typedef struct {
  b_obj obj;
  int default_jump;
  int exit_jump;
  b_table table;
} b_obj_switch;

typedef struct {
  b_obj obj;
  void *pointer;
  char *name;
  b_ptr_free_fn free_fn;
} b_obj_ptr;

// non-user objects...
b_obj_module *new_module(b_vm *vm, char *name, char *file, b_obj_module *parent);

b_obj_switch *new_switch(b_vm *vm);
b_obj_ptr *new_ptr(b_vm *vm, void *pointer);
b_obj_ptr *new_named_ptr(b_vm *vm, void *pointer, char *name);
b_obj_ptr *new_closable_named_ptr(b_vm *vm, void *pointer, char *name, b_ptr_free_fn free_fn);

// data containers
b_obj_list *new_list(b_vm *vm);
b_obj_range *new_range(b_vm *vm, int lower, int upper);

b_obj_bytes *new_bytes(b_vm *vm, int length);

b_obj_dict *new_dict(b_vm *vm);

b_obj_file *new_file(b_vm *vm, b_obj_string *path, b_obj_string *mode);

// base objects
b_obj_bound *new_bound_method(b_vm *vm, b_value receiver, b_obj_closure *method);

b_obj_class *new_class(b_vm *vm, b_obj_string *name);

b_obj_closure *new_closure(b_vm *vm, b_obj_func *function);

b_obj_func *new_function(b_vm *vm, b_obj_module *module, b_func_type type);

b_obj_instance *new_instance(b_vm *vm, b_obj_class *klass);

b_obj_up_value *new_up_value(b_vm *vm, b_value *slot);

b_obj_native *new_native(b_vm *vm, b_native_fn function, const char *name);

b_obj_string *copy_string(b_vm *vm, const char *chars, int length);

b_obj_string *take_string(b_vm *vm, char *chars, int length);

void print_object(b_value value, bool fix_string);

const char *object_type(b_obj *object);

b_obj_string *object_to_string(b_vm *vm, b_value value);

b_obj_bytes *copy_bytes(b_vm *vm, unsigned char *b, int length);

b_obj_bytes *take_bytes(b_vm *vm, unsigned char *b, int length);

static inline bool is_obj_type(b_value v, b_obj_type t) {
  return IS_OBJ(v) && AS_OBJ(v)->type == t;
}

static inline bool is_std_file(b_obj_file *file) { return file->mode->length == 0; }

#define ALLOCATE_OBJ(type, obj_type)                                           \
  (type *)allocate_object(vm, sizeof(type), obj_type)

b_obj *allocate_object(b_vm *vm, size_t size, b_obj_type type);

#define ITER_TOOL_PREPARE() \
  int arity = closure->function->arity; \
  if(arity > 0) { \
    write_list(vm, call_list, NIL_VAL); \
    if(arity > 1) { \
      write_list(vm, call_list, NIL_VAL); \
      if(arity > 2) { \
        write_list(vm, call_list, METHOD_OBJECT); \
      } \
    } \
  }

#endif

#ifndef BLADE_VM_H
#define BLADE_VM_H

typedef struct s_compiler b_compiler;


typedef enum {
  PTR_OK,
  PTR_COMPILE_ERR,
  PTR_RUNTIME_ERR,
} b_ptr_result;

typedef struct {
  b_obj_closure *closure;
  uint8_t *ip;
  b_value *slots;
  int gc_protected;
} b_call_frame;

typedef struct {
  b_call_frame *frame;
  uint16_t offset;
  b_value value;
} b_error_frame;

struct s_vm {
  b_call_frame frames[FRAMES_MAX];
  b_call_frame *current_frame;
  unsigned int frame_count;

  b_blob *blob;
  uint8_t *ip;
  b_obj_up_value *open_up_values;

  b_error_frame *errors[ERRORS_MAX];
  b_error_frame **error_top;

  size_t stack_capacity;
  b_value *stack;
  b_value *stack_top;


  b_obj *objects;
  b_compiler *compiler;
  b_obj_class *exception_class;
  char *root_file;

  // gc
  int gray_count;
  int gray_capacity;
  int gc_protected;
  b_obj **gray_stack;
  size_t bytes_allocated;
  size_t next_gc;

  // objects tracker
  b_table modules;
  b_table strings;
  b_table globals;

  // object public methods
  b_table methods_string;
  b_table methods_list;
  b_table methods_dict;
  b_table methods_file;
  b_table methods_bytes;
  b_table methods_range;

  char **std_args;
  int std_args_count;

  // boolean flags
  bool is_repl;
  bool mark_value;
  // for switching through the command line args...
  bool show_warnings;
  bool should_print_bytecode;
  bool should_exit_after_bytecode;

  // miscellaneous
};

void init_vm(b_vm *vm);

void free_vm(b_vm *vm);

b_ptr_result interpret(b_vm *vm, b_obj_module *module, const char *source);

void push(b_vm *vm, b_value value);

b_value pop(b_vm *vm);

b_value pop_n(b_vm *vm, int n);

b_value peek(b_vm *vm, int distance);

void push_error(b_vm *vm, b_error_frame *frame);
b_error_frame* pop_error(b_vm *vm);
b_error_frame* peek_error(b_vm *vm);

static inline void add_module(b_vm *vm, b_obj_module *module) {
  cond_dbg(vm->current_frame, printf("Adding module %s from %s to %s in %s\n", 
    module->name, 
    module->file, 
    vm->current_frame->closure->function->module->name, 
    vm->current_frame->closure->function->module->file
  ));

  table_set(vm, &vm->modules, STRING_VAL(module->file), OBJ_VAL(module));
  if (vm->frame_count == 0) {
    table_set(vm, &vm->globals, STRING_VAL(module->name), OBJ_VAL(module));
  } else {
    table_set(vm, &vm->current_frame->closure->function->module->values,
              STRING_VAL(module->name), OBJ_VAL(module));
  }
}

bool invoke_from_class(b_vm *vm, b_obj_class *klass, b_obj_string *name, int arg_count);

bool is_false(b_value value);

void dict_add_entry(b_vm *vm, b_obj_dict *dict, b_value key, b_value value);

bool dict_get_entry(b_obj_dict *dict, b_value key, b_value *value);

bool dict_set_entry(b_vm *vm, b_obj_dict *dict, b_value key, b_value value);

void define_native_method(b_vm *vm, b_table *table, const char *name,
                          b_native_fn function);

bool is_instance_of(b_obj_class *klass1, char *klass2_name);

bool do_throw_exception(b_vm *vm, bool is_assert, const char *format, ...);

b_obj_instance *create_exception(b_vm *vm, b_obj_string *message);

#define EXIT_VM() return PTR_RUNTIME_ERR

#define runtime_error(...)                                                     \
  if(!throw_exception(vm, ##__VA_ARGS__)){                                     \
    EXIT_VM(); \
  }

#define throw_exception(v, ...) do_throw_exception(v, false, ##__VA_ARGS__)

static inline b_obj *gc_protect(b_vm *vm, b_obj *object) {
  push(vm, OBJ_VAL(object));
  vm->frames[vm->frame_count > 0 ? vm->frame_count - 1 : 0].gc_protected++;
  return object;
}

static inline void gc_clear_protection(b_vm *vm) {
  b_call_frame *frame = &vm->frames[vm->frame_count > 0 ? vm->frame_count - 1 : 0];
  if (frame->gc_protected > 0) {
    pop_n(vm, frame->gc_protected);
  }
  frame->gc_protected = 0;
}

// NOTE:
// 1. Any call to GC() within a function/block must be accompanied by
// at least one call to CLEAR_GC() before exiting the function/block
// otherwise, expected unexpected behavior
// 2. The call to CLEAR_GC() will be automatic for native functions.
// 3. METHOD_OBJECT must be retrieved before any call to GC() in a
// native function.
#define GC(o) gc_protect(vm, (b_obj*)(o))
#define CLEAR_GC() gc_clear_protection(vm)

bool call_value(b_vm *vm, b_value callee, int arg_count);
b_value raw_closure_call(b_vm *vm, b_obj_closure *closure, b_obj_list *args, bool must_push);
b_value call_closure(b_vm *vm, b_obj_closure *closure, b_obj_list *args);
bool queue_closure(b_vm *vm, b_obj_closure *closure);
void register_module__FILE__(b_vm *vm, b_obj_module *module);

#endif

#ifndef BLADE_MEMORY_H
#define BLADE_MEMORY_H


#define GROW_CAPACITY(capacity) ((capacity) < 4 ? 4 : (capacity)*2)

#define GROW_ARRAY(type, pointer, old_count, new_count)                        \
  (type *)reallocate(vm, pointer, sizeof(type) * (old_count),                  \
                     sizeof(type) * (new_count))

#define FREE_ARRAY(type, pointer, old_count)                                   \
  reallocate(vm, pointer, sizeof(type) * (old_count), 0)

#define FREE(type, pointer) reallocate(vm, pointer, sizeof(type), 0)

#define ALLOCATE(type, count)                                                  \
  (type *)reallocate(vm, NULL, 0, sizeof(type) * (count))

#define C_ALLOCATE(type, count)                                                  \
  (type *)c_allocate(vm, sizeof(type), (count))

#define N_ALLOCATE(type, count)                                                  \
  (type *)allocate(vm, (count))

void *allocate(b_vm *vm, size_t size);
void *c_allocate(b_vm *vm, size_t size, size_t length);
void *reallocate(b_vm *vm, void *pointer, size_t old_size, size_t new_size);

void free_object(b_vm *vm, b_obj *object);
void free_objects(b_vm *vm);

void mark_object(b_vm *vm, b_obj *object);

void mark_value(b_vm *vm, b_value value);

void collect_garbage(b_vm *vm);

void blacken_object(b_vm *vm, b_obj *object);

#define OUT_OF_MEMORY() fflush(stdout); \
  fprintf(stderr, "Exit: device out of memory\n"); \
  exit(EXIT_TERMINAL)

#endif

#ifndef BLADE_NATIVE_H
#define BLADE_NATIVE_H




#define DECLARE_NATIVE(name)                                                   \
  bool native_fn_##name(b_vm *vm, int arg_count, b_value *args)

#define DECLARE_METHOD(name)                                                   \
  bool native_method_##name(b_vm *vm, int arg_count, b_value *args)

#define DECLARE_MODULE_METHOD(name)                                            \
  bool native_module_##name(b_vm *vm, int arg_count, b_value *args)

#define GET_NATIVE(name) native_fn_##name
#define GET_METHOD(name) native_method_##name
#define GET_MODULE_METHOD(name) native_module_##name

#define DEFINE_NATIVE(name) define_native(vm, #name, GET_NATIVE(name))

#define DEFINE_METHOD(table, name)                                             \
  define_native_method(vm, &vm->methods_##table, #name,                        \
                       native_method_##table##name)

// NOTE: METHOD_OBJECT must always be retrieved
// before any call to create an object in a native function.
// failure to do so will lead to the first object created
// within the function to appear as METHOD_OBJECT
#define METHOD_OBJECT args[-1]

#define NORMALIZE_IS_BOOL "bool"
#define NORMALIZE_IS_BYTES "bytes"
#define NORMALIZE_IS_NUMBER "number"
#define NORMALIZE_IS_CHAR "char"
#define NORMALIZE_IS_STRING "string"
#define NORMALIZE_IS_CLOSURE "function"
#define NORMALIZE_IS_INSTANCE "instance"
#define NORMALIZE_IS_CLASS "class"
#define NORMALIZE_IS_MODULE "module"
#define NORMALIZE_IS_LIST "list"
#define NORMALIZE_IS_DICT "dict"
#define NORMALIZE_IS_OBJ "object"
#define NORMALIZE_IS_FILE "file"
#define NORMALIZE_IS_PTR "ptr"

#define NORMALIZE(token) NORMALIZE_##token

#define RETURN do { args[-1] = EMPTY_VAL; return true; } while(0)
#define RETURN_NIL do { args[-1] = NIL_VAL; return true; } while(0)
#define RETURN_EMPTY do  { args[-1] = NIL_VAL; return false; } while(0)
#define RETURN_ERROR(...)                                                      \
  do {                                                                            \
    pop_n(vm, arg_count); \
    throw_exception(vm, ##__VA_ARGS__);                                        \
    args[-1] = FALSE_VAL; \
    return false;                                                          \
  } while(0)
#define RETURN_BOOL(v) do { args[-1] = BOOL_VAL(v); return true; } while(0)
#define RETURN_TRUE do { args[-1] = TRUE_VAL; return true; } while(0)
#define RETURN_FALSE do { args[-1] = FALSE_VAL; return true; } while(0)
#define RETURN_NUMBER(v) do { args[-1] = NUMBER_VAL(v); return true; } while(0)
#define RETURN_OBJ(v) do { args[-1] = OBJ_VAL(v); return true; } while(0)
#define RETURN_PTR(v) do { args[-1] = OBJ_VAL(new_ptr(vm, (void*)(v))); return true; } while(0)
#define RETURN_NAMED_PTR(v, g) do { args[-1] = OBJ_VAL(new_named_ptr(vm, (void*)(v), (g))); return true; } while(0)
#define RETURN_CLOSABLE_NAMED_PTR(v, g, f) do { args[-1] = OBJ_VAL(new_closable_named_ptr(vm, (void*)(v), (g), (f))); return true; } while(0)
#define RETURN_STRING(v) do { args[-1] = OBJ_VAL(copy_string(vm, v, (int)strlen(v))); return true; } while(0)
#define RETURN_L_STRING(v, l) do { args[-1] = OBJ_VAL(copy_string(vm, v, l)); return true; } while(0)
#define RETURN_T_STRING(v, l) do { args[-1] = OBJ_VAL(take_string(vm, v, l)); return true; } while(0)
#define RETURN_TT_STRING(v) do { args[-1] = OBJ_VAL(take_string(vm, v, (int)strlen(v))); return true; } while(0)
#define RETURN_VALUE(v) do { args[-1] = v; return true; } while(0)

#define WARN(...) do { \
    if(vm->show_warnings) { \
      fprintf(stderr, "WARNING: ");                  \
      fprintf(stderr, ##__VA_ARGS__);                  \
      fprintf(stderr, "\n");                  \
    }                   \
  }  while(0)

#define ENFORCE_ARG_COUNT(name, d)   do {                                          \
  if (arg_count != (d)) {                                                        \
    RETURN_ERROR(#name "() expects %d arguments, %d given", d, arg_count);     \
  } } while(0)

#define ENFORCE_MIN_ARG(name, d)    do {                                           \
  if (arg_count < (d)) {                                                         \
    RETURN_ERROR(#name "() expects minimum of %d arguments, %d given", d,      \
                 arg_count);                                                   \
  } } while(0)

#define ENFORCE_MAX_ARG(name, d)   do {                                            \
  if (arg_count < (d)) {                                                         \
    RETURN_ERROR(#name "() expects maximum of %d arguments, %d given", d,      \
                 arg_count);                                                   \
  } } while(0)

#define ENFORCE_ARG_RANGE(name, low, up)   do {                                    \
  if (arg_count < (low) || arg_count > (up)) {                                     \
    RETURN_ERROR(#name "() expects between %d and %d arguments, %d given",     \
                 low, up, arg_count);                                          \
  } } while(0)

#define ENFORCE_ARG_TYPE(name, i, type)     do {                                   \
  if (!type(args[i])) {                                                        \
    RETURN_ERROR(#name                                                         \
                 "() expects argument %d as " NORMALIZE(type) ", %s given",    \
                 (i) + 1, value_type(args[i]));                                  \
  } } while(0)

#define ENFORCE_ARG_TYPES(name, i, type1, type2)  do {                                      \
  if (!type1(args[i]) && !type2(args[i])) {                                                        \
    RETURN_ERROR(#name                                                         \
                 "() expects argument %d as " NORMALIZE(type1) " or " NORMALIZE(type2) ", %s given",    \
                 (i) + 1, value_type(args[i]));                                  \
  } } while(0)

#define ENFORCE_CONSTRUCTOR_ARG_TYPE(name, i, type)    do {                        \
  if (!type(args[i])) {                                                        \
    RETURN_ERROR(#name                                                         \
                 "() expects argument %d to class constructor as " NORMALIZE(  \
                     type) ", %s given",                                       \
                 (i) + 1, value_type(args[i]));                                  \
  } } while(0)

#define EXCLUDE_ARG_TYPE(method_name, arg_type, index)      do {                   \
  if (arg_type(args[index])) {                                                 \
    RETURN_ERROR("invalid type %s() as argument %d in %s()",                   \
                 value_type(args[index]), (index) + 1, #method_name);            \
  } } while(0)

#define METHOD_OVERRIDE(override, i)                                           \
  do {                                                                         \
    if (IS_INSTANCE(args[0])) {                                                \
      b_obj_instance *instance = AS_INSTANCE(args[0]);                         \
      b_value _tmp;                                                            \
      b_obj_string *name = (b_obj_string *)GC(copy_string(vm, "@" #override, (i) + 1)); \
      if(table_get(&instance->klass->methods, OBJ_VAL(name), &_tmp)) {         \
        CLEAR_GC(); \
        b_value val = raw_closure_call(vm, AS_CLOSURE(_tmp), 0, false); \
        args[-1] = val;                                                   \
        return false; \
      } \
    }      \
    CLEAR_GC(); \
  } while (0)

#define REGEX_COMPILATION_ERROR(re, error_number, error_offset)    do {            \
  if ((re) == NULL) {                                                            \
    PCRE2_UCHAR8 buffer[256];                                                  \
    pcre2_get_error_message_8(error_number, buffer, sizeof(buffer));           \
    RETURN_ERROR("regular expression compilation failed at offset %d: %s",     \
                 (int)(error_offset), buffer);                                   \
  } } while(0)

#define REGEX_ASSERTION_ERROR(re, match_data, ovector)      do {                   \
  if ((ovector)[0] > (ovector)[1]) {                                               \
    RETURN_ERROR(                                                            \
        "match aborted: regular expression used \\K in an assertion %.*s to "  \
        "set match start after its end.",                                      \
        (int)((ovector)[0] - (ovector)[1]), (char *)(subject + (ovector)[1]));       \
    pcre2_match_data_free(match_data);                                         \
    pcre2_code_free(re);                                                       \
    RETURN_EMPTY;                                                          \
  } } while(0)


#define REGEX_ERR(message, result) do { \
    PCRE2_UCHAR error[255]; \
    if(pcre2_get_error_message(result, error, 255)) { \
      RETURN_ERROR("RegexError: (%d) %s", result, (char*)error); \
    } \
    RETURN_ERROR("RegexError: %s", message);                \
  } while(0)

#define REGEX_RC_ERROR() REGEX_ERR("%d", rc);

#define GET_REGEX_COMPILE_OPTIONS(string, regex_show_error)             \
  int32_t compile_options = is_regex(string);  do {                               \
  if ((regex_show_error) && (int)compile_options == -1) {                        \
    RETURN_ERROR("RegexError: Invalid regex");          \
  } else if ((regex_show_error) && (int)compile_options > 1000000) {                  \
    RETURN_ERROR("RegexError: invalid modifier '%c' ",       \
                 (char)abs(1000000 - (int)compile_options));                             \
  } } while(0)


#define GC_STRING(o) OBJ_VAL(GC(copy_string(vm, (o), (int)strlen(o))))
#define GC_L_STRING(o, l) OBJ_VAL(GC(copy_string(vm, (o), (l))))
#define GC_T_STRING(o, l) OBJ_VAL(GC(take_string(vm, (o), (l))))
#define GC_TT_STRING(o) OBJ_VAL(GC(take_string(vm, (o), (int)strlen(o))))

extern int32_t is_regex(b_obj_string *string);

extern char *remove_regex_delimiter(b_vm *vm, b_obj_string *string);

extern void write_list(b_vm *vm, b_obj_list *list, b_value value);

extern b_obj_list *copy_list(b_vm *vm, b_obj_list *list, int start, int length);

#endif

#ifndef BLADE_MODULE_H
#define BLADE_MODULE_H


typedef struct {
  const char *name;
  bool is_static;
  b_native_fn function;
} b_func_reg;

typedef b_value (*b_class_field)(b_vm *);

typedef void (*b_module_loader)(b_vm *);

typedef struct {
  const char *name;
  bool is_static;
  b_class_field field_value;
} b_field_reg;

typedef struct {
  const char *name;
  b_field_reg *fields;
  b_func_reg *functions;
} b_class_reg;

typedef struct {
  const char *name;
  b_field_reg *fields;
  b_func_reg *functions;
  b_class_reg *classes;
  b_module_loader preloader;
  b_module_loader unloader;
} b_module_reg;

typedef b_module_reg* (*b_module_init)(b_vm *);

#define CREATE_MODULE_LOADER(module)                                           \
  b_module_reg* blade_module_loader_##module(b_vm *vm)
#define GET_MODULE_LOADER(module) &blade_module_loader_##module

void bind_native_modules(b_vm *vm);
void add_native_module(b_vm *vm, b_obj_module *module, const char *as);
bool load_module(b_vm *vm, b_module_init init_fn, char *name, char *source, void *handle);
char* load_user_module(b_vm *vm, const char *path, char *name);
void close_dl_module(void* handle);
void free_module(b_vm *vm, b_obj_module *module);

#endif


#ifndef EXPORT_H
#define EXPORT_H

#ifdef SHARED_EXPORTS_BUILT_AS_STATIC
#  define EXPORT
#  define LIBBLADE_NO_EXPORT
#else
#  ifndef EXPORT
#    ifdef libblade_EXPORTS
        /* We are building this library */
#      define EXPORT __attribute__((visibility("default")))
#    else
        /* We are using this library */
#      define EXPORT __attribute__((visibility("default")))
#    endif
#  endif

#  ifndef LIBBLADE_NO_EXPORT
#    define LIBBLADE_NO_EXPORT __attribute__((visibility("hidden")))
#  endif
#endif

#ifndef LIBBLADE_DEPRECATED
#  define LIBBLADE_DEPRECATED __attribute__ ((__deprecated__))
#endif

#ifndef LIBBLADE_DEPRECATED_EXPORT
#  define LIBBLADE_DEPRECATED_EXPORT EXPORT LIBBLADE_DEPRECATED
#endif

#ifndef LIBBLADE_DEPRECATED_NO_EXPORT
#  define LIBBLADE_DEPRECATED_NO_EXPORT LIBBLADE_NO_EXPORT LIBBLADE_DEPRECATED
#endif

/* NOLINTNEXTLINE(readability-avoid-unconditional-preprocessor-if) */
#if 0 /* DEFINE_NO_DEPRECATED */
#  ifndef LIBBLADE_NO_DEPRECATED
#    define LIBBLADE_NO_DEPRECATED
#  endif
#endif

#endif /* EXPORT_H */

