#!-- part of the curl module

import _curl

/**
 * cURL request options for `set_option()`
 */
class UseSSL {

   /**
    * Do not attempt to use SSL.
    * @static
    */
   static var NONE = _curl.CURLUSESSL_NONE

   /**
    * Try using SSL, proceed anyway otherwise.
    * @static
    */
   static var TRY = _curl.CURLUSESSL_TRY

   /**
    * Use SSL for the control connection or fail.
    * @static
    */
   static var CONTROL = _curl.CURLUSESSL_CONTROL

   /**
    * Use SSL for all communication or fail
    * @static
    */
   static var ALL = _curl.CURLUSESSL_ALL
}
